<script lang="ts">
  import { Toggle, Radio, Dropdown, Button } from 'flowbite-svelte';
  import { faChevronDown, faChevronUp } from '@fortawesome/free-solid-svg-icons';
  import Fa from 'svelte-fa';
  import MultiSelect from '$lib/filters/MultiSelect.svelte';
  import { EngagementData } from '$lib/data/engagementData';
  import type { Competition } from '@types';
  import { SortByParticipation, SortByName } from '$lib/data/util';

  export let events: Competition[] = [];
  export let collapsed = false;
  export let showSorting = false;
  let clazz = '';
  export { clazz as class };

  let sortBy = 'participation';
  let sortOptions = ['name', 'participation'];

  // save full list of events for use later using default sorting
  let allEvents: Competition[] = sortCompetitions(events);
  $: if (sortBy) {
    events = sortCompetitions(events);
  }

  let locationSelectedItems: string[] = [];
  let educationTargetsSelectedItems: string[] = [];
  let qualifiersSelectedItems: string[] = [];
  let tagsSelectedItems: string[] = [];

  let practiceFilter = false;
  let hideConferenceFilter = false;
  $: events = getSelection(
    tagsSelectedItems,
    educationTargetsSelectedItems,
    locationSelectedItems,
    qualifiersSelectedItems,
    practiceFilter,
    hideConferenceFilter
  );

  const educationTargets = [
    ...new Set(
      Object.values(EngagementData.data.competitions)
        .map((e) => {
          if (e.properties.education_target) {
            return e.properties.education_target;
          }
          return [];
        })
        .flat()
    )
  ];
  const tags = EngagementData.data.tags;

  const locations = ['Virtual Only', 'In-person Only'];
  const qualifierOptions = ['Qualifiers', 'No Qualifiers'];

  function clearSelections() {
    tagsSelectedItems = [];
    educationTargetsSelectedItems = [];
    locationSelectedItems = [];
    qualifiersSelectedItems = [];
    practiceFilter = false;
    hideConferenceFilter = false;
    sortBy = 'participation';
  }

  function sortCompetitions(comps: Competition[]) {
    if (sortBy == 'participation') {
      return SortByParticipation(comps);
    } else {
      return SortByName(comps);
    }
  }

  function getSelection(
    tags: string[],
    educationTargets: string[],
    locations: string[],
    qualifiers: string[],
    practice: boolean,
    hideConference: boolean
  ) {
    // If no filters are enabled, then don't filter
    if (
      tags.length == 0 &&
      educationTargets.length == 0 &&
      locations.length == 0 &&
      qualifiers.length == 0 &&
      !practice &&
      !hideConference
    ) {
      return allEvents;
    }
    return allEvents.filter((e) => {
      // boolean OR within groups, boolean AND between groups
      return (
        (tags.length == 0 || e.properties.tags.some((t) => tags.includes(t))) &&
        (educationTargets.length == 0 || e.properties.education_target?.some((t) => educationTargets.includes(t))) &&
        (locations.length == 0 ||
          (locations.includes('Virtual Only') && e.properties.virtual === true) ||
          (locations.includes('In-person Only') && e.properties.virtual === false)) &&
        (qualifiers.length == 0 ||
          (qualifiers.includes('Qualifiers') && e.properties.qualifiers === true) ||
          (qualifiers.includes('No Qualifiers') && e.properties.qualifiers === false)) &&
        (!practice || (practice && e.properties.practice_available)) &&
        (!hideConference || (hideConference && !e.properties.tags.includes('Conference')))
      );
    });
  }
</script>

<div class="bg-slate-50 border border-slate-600/25 shadow-xl dark:text-white dark:bg-gray-800 p-3 {clazz}">
  <div class="flex flex-inline align-center text-xl md:text-2xl font-extrabold">
    <div
      class="cursor-pointer"
      tabindex="0"
      role="button"
      aria-pressed="false"
      on:click={() => (collapsed = !collapsed)}
      on:keydown={() => (collapsed = !collapsed)}>
      <h1>
        <Fa class="inline-block" icon={collapsed ? faChevronDown : faChevronUp} />
        Filters {showSorting ? '& Sorting' : ''} ({events.length})
      </h1>
    </div>
    {#if !collapsed}
      <Button
        outline
        class="py-1 px-3 ml-auto md:ml-3 mt-1"
        on:click={() => {
          clearSelections();
        }}
        color="red">Reset</Button>
    {/if}
  </div>
  <div class:hidden={collapsed}>
    <!-- Dropdowns and Toggles -->
    <div class="flex flex-wrap flex-col items-left lg:flex-row mt-2">
      <MultiSelect bind:selectedItems={locationSelectedItems} label="Location" items={locations} />
      <MultiSelect bind:selectedItems={educationTargetsSelectedItems} label="Education" items={educationTargets} />
      <MultiSelect bind:selectedItems={tagsSelectedItems} label="Tags" items={tags} />
      <MultiSelect bind:selectedItems={qualifiersSelectedItems} label="Qualifiers" items={qualifierOptions} />

      <!-- Push Toggles to right side on large screens -->
      <div class="mx-auto" />

      <Toggle bind:checked={practiceFilter} class="cursor-pointer lg:ms-2 my-2 max-lg:mx-auto">
        Practice Available
      </Toggle>
      <Toggle bind:checked={hideConferenceFilter} class="cursor-pointer lg:ms-2 my-2 max-lg:mx-auto">
        Hide Conferences
      </Toggle>
      {#if showSorting}
        <div class="mx-2 my-1 border-t-2 border-r-0 lg:border-t-0 lg:pl-3 lg:border-r-2" />
        <Button color="none" class="px-3 !text-left focus-within:ring-0">
          Sort By <Fa icon={faChevronDown} class="w-3 h-3 ms-2" />
        </Button>
        <Dropdown class="p-3 space-y-3 text-sm">
          {#each sortOptions as item}
            <li>
              <Radio class="cursor-pointer" name="sortBy" bind:group={sortBy} value={item}>{item}</Radio>
            </li>
          {/each}
        </Dropdown>
      {/if}
    </div>
  </div>
</div>
